//-< Conversion.java >-----------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     22-Oct-98    K.A. Knizhnik  * / [] \ *
//                          Last update: 22-Oct-98    K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Some primitives for providing compatibilities with C++ data type
//-------------------------------------------------------------------*--------*
namespace Goods
{
    using System;
	
    /// <summary> Class responsible for string conversions
    /// </summary>
    public class Conversion
    {
        /// 
        /// <summary> Conversion of zero terminated C++ string to Java Unicode String.
        /// High byte of unicode character is set to 0, so only ASCII characters
        /// will be corretly converted by this function. 
        /// </summary>
        public static String AsciizToString(byte[] b)
        {
            int len = b.Length;
            char[] chars = new char[len];
            for (int i = 0; i < len; i++) 
            { 
                chars[i] = (char)b[i];
            }
            return new String(chars);
        }
		
        public static byte[] StringToAsciiz(String s)
        {
            int length = s.Length;
            byte[] b = new byte[length + 1];
            int i;
            int j;
            i = 0;
            j = 0;
            while (i < length)
            {
                b[j] = (byte) s[i];
                i++;
                j++;
            }
            b[length] = 0;
            return b;
        }
    }
}