//-< Server.java >---------------------------------------------------*--------*
// GOODS                      Version 2.02       (c) 1998  GARRET    *     ?  *
// (Generic Object Oriented Database System)                         *   /\|  *
// Java Program Interface                                            *  /  \  *
//                          Created:     23-Sep-2001  K.A. Knizhnik  * / [] \ *
//                          Last update: 23-Sep-2001  K.A. Knizhnik  * GARRET *
//-------------------------------------------------------------------*--------*
// Class representing GOODS server process
//-------------------------------------------------------------------*--------*
namespace Goods
{
    using System;
	
    /// <summary> Class for launching GOODS server process
    /// </summary>
    public class Server
    {
        protected internal System.Diagnostics.Process process;
        protected internal System.IO.StreamWriter pipeOut;
        protected internal System.IO.StreamReader pipeIn;
        protected internal String cfgFileName;
		
        public Server(String cfgFileName)
        {
            if (cfgFileName.EndsWith(".cfg"))
            {
                cfgFileName = cfgFileName.Substring(0, cfgFileName.Length - 4);
            }
            this.cfgFileName = cfgFileName;
        }
		
        public virtual void  start()
        {
            process = System.Diagnostics.Process.Start(new System.Diagnostics.ProcessStartInfo("goodsrv", cfgFileName));
            pipeOut = process.StandardInput;
            pipeIn = process.StandardOutput;
        }
		
        public virtual System.IO.StreamReader command(String cmd)
        {
            pipeOut.WriteLine(cmd);
            pipeOut.Flush();
            return pipeIn;
        }
		
        public virtual void  stop()
        {
            command("exit");
            process.WaitForExit();
        }
    }
}