package org.dcg.datamgr.admin;

import java.util.Map;
/**
 * @author dacosta
 *
 * This interface defines the methods required to manage the index structure.<br>
 * These methods take care of initializing the classes into the index structure, modifying and deleting them as well.<br>
 * The central abstract DataMgr should know about this as well as the actual DataMgrs that responsible for the actual implementation to the different types (brands) of databases.<br>
 */
public interface IndexMgrIF {

	/**
	 * Take the object, go through its public attributes & insert them into the index structure
	 */
	void setIndexAttributes(Object o);

	Map getIndexAttributes(Object o);

	void modifyIndexAttributes(Object o);

}
